const DB = require("../database/DB");
const updaterModelCasher = require("../model/updaterModelCasher");
const UpdaterUnitProduct = require("../provider/UpdaterUnitProduct");

class CasherController {
  async handleCasherWithoutProduct({ CDFILIAL }) {
    const casherAndProducts = await updaterModelCasher.getCasherWithoutProduct({
      CDFILIAL,
    });
    if(casherAndProducts && casherAndProducts.rows && casherAndProducts.rows.length) {
      const connection = await DB.beginTransaction();
      await Promise.all(casherAndProducts.rows.map((rowToInsert) => {
        return UpdaterUnitProduct.insert(rowToInsert, { connection });
      }))
      .then(() => connection.commit())
      .catch(() => connection.rollback())
      .finally(() => connection.close());
    }
  }
}

module.exports = new CasherController();