const UpdaterLogger = require('../logs/UpdaterLogger');
const Updater = require('../socket/events/Updater');
const SocketManager = require('../socket/SocketManager');

class LogController {
  async setUpdaterLog(file, param) {
    const { CDFILIAL, CDCAIXA } = param;
    const downloadLogRoomName = Updater.getDownloadLogRoom(CDFILIAL, CDCAIXA, 'txt');
    const downloadLogRoom = SocketManager.getRoom(downloadLogRoomName);

    if (file && downloadLogRoom) {
      this.updaterLog = {
        file,
        param
      };
      downloadLogRoom.emit('downloadLogResult', { error: false, message: 'SUCCESS_UPLOAD_LOG', param });
    }
  }

  async getUpdaterLog(){
    return this.updaterLog;
  }

  clearLogFile() {
    this.updaterLog = {};
  }

  async setLogZipFile(file, param) {
    try {
      const { CDFILIAL, CDCAIXA, PRODUCT } = param;
      const downloadLogRoomName = Updater.getDownloadLogRoom(CDFILIAL, CDCAIXA, 'zip');
      const roomDownloadLog = SocketManager.getRoom(downloadLogRoomName);

      if (file && roomDownloadLog) {
        const { fileName, error, message } = await UpdaterLogger.writeZip(CDFILIAL, CDCAIXA, PRODUCT, Buffer.from(file));
        if(error) {
          roomDownloadLog.emit('downloadLogResult', {error, message, param});
        } else {
          param.downloadUrl = `/updater-logs/${fileName}`
          roomDownloadLog.emit('downloadLogResult', { error: false, message: 'UPLOAD_ZIPLOG_SUCCESS', param });
        }
      }
    } catch (error) {
      SystemLogger.write(error);
    }
  }

}

module.exports = new LogController();