const fs = require('fs');
const path = require('path');
const currentPath = path.dirname(process.argv[1]);
const envPath = path.join(currentPath, '.env');

require('dotenv').config({path: envPath});

class Environment {
  async readFile() {
    return new Promise((resolve, reject) => {
      fs.readFile(envPath, { encoding: 'utf-8' }, (err, data) => {
        if(err) return reject(err);
        resolve(data);
      });
    });
  }
  async writeFile(content) {
    return new Promise((resolve, reject) => {
      fs.writeFile(envPath, content, (err) => {
        if(err) return reject(err);
        resolve();
      });
    });
  }
}

module.exports = new Environment();