const path = require('path');
const { Router } = require('express');
const { readdirSync } = require('fs');
const backendPath = path.dirname(process.argv[1]);
const routesPath = path.join(backendPath, 'app', 'routes');

class RouteManager {
  register(server){
    const router = Router();
    server.use('/', router);

    readdirSync(routesPath).forEach(async file => {
      (await require(path.join(routesPath, file)))(router);
    })
  }
}

module.exports = new RouteManager();