const cors = require('cors');
const express = require('express');
const ServeIndex = require('serve-index');
const AuthMiddleware = require('./Auth');
const LogMiddleware = require('./Log');

const limit = '50mb';

class App {
  register(server) {
    server.use(cors());
    server.use(express.json({ limit }));;
    server.use(express.urlencoded({ extended: false, limit }));

    LogMiddleware.register(server);
    AuthMiddleware.register(server);

    const { UPDATER_LOG_FOLDER } = process.env;
    if(UPDATER_LOG_FOLDER) {
      server.use(
        '/updater-logs',
        express.static(UPDATER_LOG_FOLDER),
        ServeIndex(UPDATER_LOG_FOLDER, { icons: false })
      );
    }
  }
}

module.exports = new App();