const DB = require('../database/DB');

class Filial {
  GET_ACTIVE_UNITS = `
    SELECT
      CDFILIAL,
      NMFILIAL,
      CDFILIAL || ' - ' || NMFILIAL AS FILIAL
    FROM
      FILIAL
    WHERE
      IDATIVO = 'S'
    ORDER BY
      CDFILIAL
  `;

  GET_UNITS = `
    SELECT
      F.CDFILIAL,
      F.NMFILIAL,
      F.NRORG,
      (
        SELECT
          COUNT(1)
        FROM CAIXA C
        WHERE
          C.CDFILIAL = F.CDFILIAL AND
          C.IDTPEMISSAOFOS = 'SAT'
      ) AS SAT
      FROM FILIAL F
      WHERE
        UPPER(F.NMFILIAL) NOT LIKE '%INAT%'
      GROUP BY
        F.CDFILIAL,
        F.NMFILIAL,
        F.NRORG
    ORDER BY
    F.CDFILIAL
  `;

  GET_UNITS_WITH_CASHER = `
    SELECT
      R.CDREGIAO,
      F.CDFILIAL,
      F.NMFILIAL
    FROM
      FILIAL F
      LEFT JOIN REGIAO R ON (F.CDREGIAO = R.CDREGIAO)
    WHERE
      UPPER(F.NMFILIAL) NOT LIKE '%INAT%'
      AND F.CDFILIAL IN (
        SELECT
          CDFILIAL
        FROM 
          CAIXA
        )
    AND (R.SGESTADO = :SGESTADO OR :SGESTADO IS NULL)
  `;

  getActiveUnits() {
    return DB.fetch(this.GET_ACTIVE_UNITS);
  }

  getUnits() {
    return DB.fetch(this.GET_UNITS);
  }

  getUnitsWithCasher(params) {
    return DB.fetch(this.GET_UNITS_WITH_CASHER, params);
  }
}

module.exports = new Filial();