const DB = require('../database/DB');

class UpdaterConfig {
  INSERT = `
    INSERT INTO UPDATERCONFIG (
      CDFILIAL,
      CONFIG
    ) VALUES (
      :P_CDFILIAL,
      :P_CONFIG
    )
  `;

  UPDATE = `
    UPDATE
      UPDATERCONFIG
    SET
      CONFIG = :P_CONFIG,
      DTULTATU = SYSDATE
    WHERE
      CDFILIAL = :P_CDFILIAL
  `;

  GET_CONFIG_INI = `
    SELECT
      ID,
      CONFIG,
      DTULTATU
    FROM
      UPDATERCONFIG
    WHERE
      CDFILIAL = :P_CDFILIAL
  `;


  insert(params, executionParams = {}) {
    const execParams = Object.assign({}, {
      outParams: [{name: 'ID', type: "number"}]
    }, executionParams);
    return DB.execute(this.INSERT, params, execParams);
  }

  update(params, executionParams = {}) {
    const execParams = Object.assign({}, {
      outParams: [{name: 'ID', type: "number"}]
    }, executionParams);
    return DB.execute(this.UPDATE, params, execParams);
  }

  getConfigIni(params) {
    return DB.fetch(this.GET_CONFIG_INI, params);
  }
}

module.exports = new UpdaterConfig();