const DB = require('../database/DB');

class UpdaterConfigCx {
  INSERT = `
    INSERT INTO UPDATERCONFIGCX (
      CDFILIAL,
      CDCAIXA,
      CONFIG
    ) VALUES (
      :P_CDFILIAL,
      :P_CDCAIXA,
      :P_CONFIG
    )
  `;

  UPDATE = `
    UPDATE
      UPDATERCONFIGCX
    SET
      CONFIG = :P_CONFIG,
      DTULTATU = SYSDATE
    WHERE
      CDFILIAL = :P_CDFILIAL
      AND CDCAIXA = :P_CDCAIXA
  `;

  GET_CONFIG_INI = `
    SELECT
      ID,
      CONFIG,
      DTULTATU
    FROM
      UPDATERCONFIGCX
    WHERE
      CDFILIAL = :P_CDFILIAL
      AND CDCAIXA = :P_CDCAIXA
  `;


  insert(params, executionParams = {}) {
    const execParams = Object.assign({}, {
      outParams: [{name: 'ID', type: "number"}]
    }, executionParams);
    return DB.execute(this.INSERT, params, execParams);
  }

  update(params, executionParams = {}) {
    const execParams = Object.assign({}, {
      outParams: [{name: 'ID', type: "number"}]
    }, executionParams);
    return DB.execute(this.UPDATE, params, execParams);
  }

  getConfigIni(params) {
    return DB.fetch(this.GET_CONFIG_INI, params);
  }
}

module.exports = new UpdaterConfigCx();