const DB = require("../database/DB");

class UpdaterConfigHist {
  INSERT = `
    INSERT INTO
    UPDATERCONFIGHIST (
      UPDATERCONFIGID,
      CDOPERADOR,
      CONFIG,
      DTINCLUSAO,
      DTULTATU
    ) VALUES (
      :P_UPDATERCONFIGID,
      :P_CDOPERADOR,
      :P_CONFIG,
      SYSDATE,
      SYSDATE
    )
  `;

  GET_CONFIG_HIST = `
    SELECT
      U.ID,
      U.CDOPERADOR,
      O.NMOPERADOR,
      TO_CHAR(U.DTULTATU, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATU
    FROM
      UPDATERCONFIGHIST U
      JOIN OPERADOR O ON (U.CDOPERADOR = O.CDOPERADOR)
    WHERE
      U.UPDATERCONFIGID = :P_ID
    ORDER BY
      ID DESC
  `;

  insert(params, executionParams = {}) {
    return DB.execute(this.INSERT, params, executionParams);
  }

  getConfigHist(params) {
    return DB.fetch(this.GET_CONFIG_HIST, params);
  }
}

module.exports = new UpdaterConfigHist();