const DB = require('../database/DB');

class UpdaterServicoFili {
  UPDATE = `
    UPDATE
      UPDATERSERVICOFILI
    SET
      MONITORAMENTO = :P_MONITORAMENTO
    WHERE
      CDFILIAL = :P_CDFILIAL
  `;

  INSERT = `
    INSERT INTO UPDATERSERVICOFILI 
      (
        CDFILIAL, 
        MONITORAMENTO, 
        NRORG, 
        DTINCLUSAO, 
        DTULTATU, 
        NRORGINCLUSAO, 
        NRORGULTATU
      ) 
      VALUES (
        :P_CDFILIAL, 
        :P_MONITORAMENTO, 
        :P_NRORG, 
        SYSDATE, 
        SYSDATE, 
        :P_NRORGINCLUSAO, 
        :P_NRORGULTATU
      )
  `;
  
  GET_SERVICE_MONITORING = `
    SELECT
      CDFILIAL,
      MONITORAMENTO
    FROM
      UPDATERSERVICOFILI
    WHERE
      MONITORAMENTO IS NOT NULL
  `;
  GET_SERVICE_MONITORING_BY_UNIT = `
    SELECT
      CDFILIAL,
      MONITORAMENTO
    FROM
      UPDATERSERVICOFILI
    WHERE
      CDFILIAL = :P_CDFILIAL
  `;

  GET_MONITORED_UNITS = `
    SELECT
      U.CDFILIAL,
      F.NMFILIAL
    FROM
      UPDATERSERVICOFILI U
      LEFT JOIN FILIAL F ON (F.CDFILIAL = U.CDFILIAL)
    WHERE
      MONITORAMENTO IS NOT NULL
    ORDER BY CDFILIAL
  `

  update(params, executionParams = {}) {
    return DB.execute(this.UPDATE, params, executionParams);
  }

  insert(params, executionParams = {}) {
    return DB.execute(this.INSERT, params, executionParams);
  }

  getAllServiceMonitoring() {
    return DB.fetch(this.GET_SERVICE_MONITORING);
  }

  getMonitoredUnits() {
    return DB.fetch(this.GET_MONITORED_UNITS);
  }

  getServiceMonitoring(params) {
    return DB.fetch(this.GET_SERVICE_MONITORING_BY_UNIT, params);
  }

}

module.exports = new UpdaterServicoFili();