const Updater = require('./events/Updater');
const UpdaterWarning = require("../helpers/UpdaterWarning");

class UpdaterHandler {
  async getMapConnectedSockets() {
    const socket = await Updater.getUpdaters();
    const result = {};
    socket.forEach(({ CDFILIAL, CDCAIXA }) => {
      const WARNING_INFO = UpdaterWarning.getWarning({ unit: CDFILIAL, casher: CDCAIXA });
      const WARNING = WARNING_INFO && WARNING_INFO.length;
      if (CDCAIXA) {
        result[CDFILIAL] = result[CDFILIAL] || { withCasher: true };
        result[CDFILIAL][CDCAIXA] = {
          WARNING,
          WARNING_INFO,
        }
      } else {
        result[CDFILIAL] = {
          WARNING,
          WARNING_INFO,
        };
      }
    });
    return result;
  }
}

module.exports = new UpdaterHandler();