const SystemLogger = require("../../logs/SystemLogger");
const Monitoring = require("./pages/Monitoring");
const MonitoringCloud = require("./pages/MonitoringCloud");
const Parametrization = require("./pages/Parametrization");
const ServiceManagement = require("./pages/ServiceManagement");
const SystemManagement = require("./pages/SystemManagement");

class Portal {
  register(socket, { page, origin }) {
    const pages = {
      monitoring: Monitoring,
      updates: SystemManagement,
      updatesPerCasher: SystemManagement,
      parametrizations: Parametrization,
      parametrizationsPerCasher: Parametrization,
      monitoringCloud: MonitoringCloud,
      serviceManagement: ServiceManagement,
      serviceManagementPerCasher: ServiceManagement,
    };
    process.env.SOCKET_ORIGIN = origin;
    const targetClass = pages[page];
    if (typeof targetClass === 'object' && typeof targetClass.register === 'function') {
      return targetClass.register.apply(targetClass, [socket, { page }]);
    } else {
      SystemLogger.error(`Invalid page name or class structure: ${page}`);
    }
  }
}

module.exports = new Portal();
