const MonitoringData = require('../../MonitoringData');
const SocketRooms = require('../../SocketRooms');
const Monitor = require('../Monitor');

class Monitoring {
  register(socket) {
    socket.join(SocketRooms.master.monitoringPage);
    Monitor.connectedUser();
    socket.on("getLatestMonitoringResult", () => {
      const summary = MonitoringData.getSummary();
      socket.emit('monitoringResultSummary', summary);
    });

    socket.on("detailMonitoring", (config) => {
      const result = MonitoringData.get({
          id: config.ID,
          unit: config.CDFILIAL,
          casher: config.CDCAIXA || null,
      }) || [];
      socket.emit("detailMonitoringResult", result);
    });
  }
}

module.exports = new Monitoring();