import { IRequestConfig } from '@zeedhi/core/types/http';

export class AddRequestSuccess {
  public static routesIgnoredInRequest = ['/login'];

  public static addHeaders(config: IRequestConfig) {
    const route: string = config.url || '';
    if (!AddRequestSuccess.routesIgnoredInRequest.includes(route)) {
      const token = localStorage.getItem('TOKEN');
      const nrorg = localStorage.getItem('NRORG');
      const node = localStorage.getItem('ASSISTANT_NODE');

      if (token) {
        config.headers.Authorization = token;
        config.headers.Nrorg = nrorg;
        config.headers.AssistantNode = node;
      }
    }
  }
}
